#include "windows.h"
#include <string.h>
#include <stdio.h>
#include "generic.h"
#include "wet.h"

HANDLE hInst;

int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;
HANDLE hPrevInstance;
LPSTR lpCmdLine;
int nCmdShow;
{
   MSG msg;

   if (!hPrevInstance)
      if (!InitApplication(hInstance))
         return FALSE;
   if (!InitInstance(hInstance, nCmdShow))
      return FALSE;
   while (GetMessage(&msg, NULL, NULL, NULL))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   return msg.wParam;
}


/*------------------------  InitApplication()  -----------------------------*/

BOOL InitApplication(hInstance)
HANDLE hInstance;
{
   WNDCLASS wc;

   wc.style = NULL;
   wc.lpfnWndProc = MainWndProc;
   wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
   wc.hInstance = hInstance;
   wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
   wc.hCursor = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = GetStockObject(WHITE_BRUSH);
   wc.lpszMenuName = "GenericMenu";
   wc.lpszClassName = "GenericWClass";
   return RegisterClass(&wc);
}


/*--------------------------  InitInstance() -------------------------------*/

BOOL InitInstance(hInstance, nCmdShow)
HANDLE hInstance;
int nCmdShow;
{
   HWND hWnd;

   hInst = hInstance;
   hWnd = CreateWindow("GenericWClass", "Generic Sample Application",
                       WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance,
                       NULL);
   if (!hWnd)
      return (FALSE);
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   return (TRUE);
}


/*--------------------------  MainWndProc()  -------------------------------*/

long FAR PASCAL MainWndProc(hWnd, message, wParam, lParam)
HWND hWnd;
unsigned message;
WORD wParam;
LONG lParam;
{
   FARPROC lpProcDemo;

   switch (message)
      {

   case WM_COMMAND:
      if (wParam == IDM_DEMO)
      {
         lpProcDemo = MakeProcInstance(Demo, hInst);
         DialogBox(hInst, "DemoBox", hWnd, lpProcDemo);
         FreeProcInstance(lpProcDemo);
         break;
      }
      else
         return DefWindowProc(hWnd, message, wParam, lParam);

   case WM_DESTROY:
      PostQuitMessage(0);
      break;

   default:
      return DefWindowProc(hWnd, message, wParam, lParam);
      }
   return (NULL);
}


/*----------------------------  About()  -----------------------------------*/

BOOL FAR PASCAL Demo(hDlg, message, wParam, lParam)
HWND hDlg;
unsigned message;
WORD wParam;
LONG lParam;
{
   HWND hCtl;
   int block_length;
   unsigned char block[100];
   unsigned char work_string[100];
   unsigned char code_key[9]="Test Key";
   switch (message)
   {
      case WM_INITDIALOG: lstrcpy(block,"This is a test 0123456789");
                          block_length=16;  // just encrypt 1st 16 characters
                          sprintf(work_string,"Clear Text:\t\t  %s",block);
                          hCtl = GetDlgItem(hDlg,IDD_CLEARTEXT);
                          SendMessage(hCtl,WM_SETTEXT,0,(LONG)(LPSTR)work_string);
                          EncryptXORBlock((LPSTR)block,block_length,(LPSTR)code_key);
                          EncryptTranspositionBlock((LPSTR)block,block_length,(LPSTR)code_key);
                          EncryptSubstitutionBlock((LPSTR)block,block_length,(LPSTR)code_key);
                          sprintf(work_string,"Encrypted (1st 16 char):\t  %s",block);
                          hCtl = GetDlgItem(hDlg,IDD_ENCRYPTEDTEXT);
                          SendMessage(hCtl,WM_SETTEXT,0,(LONG)(LPSTR)work_string);
                          EncryptSubstitutionBlock((LPSTR)block,block_length,(LPSTR)code_key);
                          EncryptTranspositionBlock((LPSTR)block,block_length,(LPSTR)code_key);
                          EncryptXORBlock((LPSTR)block,block_length,(LPSTR)code_key);
                          sprintf(work_string,"Decrypted Text:\t\t  %s",block);
                          hCtl = GetDlgItem(hDlg,IDD_DECRYPTEDTEXT);
                          SendMessage(hCtl,WM_SETTEXT,0,(LONG)(LPSTR)work_string);
                          return TRUE;

   case WM_COMMAND:
      if (wParam == IDOK || wParam == IDCANCEL)
      {
         EndDialog(hDlg, TRUE);
         return TRUE;
      }
      break;

   default:
      break;
      }
   return FALSE;
}

